<template>
  <v-row justify="center">
    <v-dialog
      v-model="rolesUpdate.open"
      @keydown.esc="handleClose"
      @click:outside="handleClose"
      width="90%"
    >
      <v-card>
        <v-toolbar style="position:relative" color="white" elevation="0">
          <v-spacer />
          <v-toolbar-title class="mt-5">
            <span class="primary--text">
              <v-icon large color="primary" class="mr-2 pb-1">mdi-bookmark</v-icon
              ><b>Editar Paepel</b>
            </span>
          </v-toolbar-title>
          <v-spacer />
          <v-tooltip color="red" bottom>
            <template v-slot:activator="{ on }">
              <v-icon
                v-on="on"
                style="position:absolute; right: 15px"
                color="red"
                @click="handleClose"
                >mdi-close</v-icon
              >
            </template>
            <span><b>Fechar</b> janela</span>
          </v-tooltip>
        </v-toolbar>
        <v-card-text style="max-width: 99% !important;" class="scrollForm">
          <v-form ref="form" v-model="valid">
            <v-container>
              <v-row>
                <v-col cols="12" sm="12" md="12">
                  <v-text-field
                    autofocus
                    v-model="role.label"
                    label="Nome*"
                    required
                    prepend-icon="mdi-pencil-box-outline"
                  ></v-text-field>
                </v-col>
                <v-col v-for="(module, index) in entityModules" :key="index" cols="12">
                  <v-row justify="center">
                    <h2 class="primary--text">{{ module.label }}</h2>
                  </v-row>
                  <v-divider class="mt-4" />
                  <v-row>
                    <v-col
                      v-for="(action, actionIndex) in entityModules[index].actions"
                      :key="actionIndex"
                      lg="2"
                      md="3"
                      sm="4"
                      xs="12"
                    >
                      <v-checkbox
                        :key="action.id"
                        v-model="role.actions"
                        :label="action.label"
                        :value="action.id"
                        color="primary"
                        hide-details
                      ></v-checkbox>
                    </v-col>
                  </v-row>
                  <v-divider />
                </v-col>
              </v-row>
            </v-container>
          </v-form>
        </v-card-text>
        <v-card-actions class="mt-n3 pb-6 pr-6">
          <v-spacer />
          <v-btn color="lighter" text @click="handleClose">Cancelar</v-btn>
          <v-btn color="primary" @click="handleUpdate" elevation="0">Salvar</v-btn>
        </v-card-actions>
      </v-card>
    </v-dialog>
  </v-row>
</template>

<script>
import { mapMutations, mapState } from 'vuex'
import Management from '../../services/management'

export default {
  name: 'RolesUpdate',
  components: {},
  data: () => ({
    role: {
      label: '',
      id: '',
      actions: [],
    },
    valid: false,
  }),
  computed: {
    ...mapState('user', ['rolesUpdate', 'entityModules']),
  },
  watch: {
    rolesUpdate(roleState) {
      if (roleState.open === true) {
        let roleActions = roleState.roleUpdated.actions
        let actionsArray = []
        roleActions.forEach((action) => {
          actionsArray.push(action.id)
        })
        this.role = {
          label: roleState.roleUpdated.label,
          id: roleState.roleUpdated.id,
          actions: actionsArray,
        }
      }
    },
  },
  methods: {
    ...mapMutations('user', ['UPDATE_ROLES_UPDATE', 'UPDATE_LOADING']),
    async handleClose() {
      await this.UPDATE_ROLES_UPDATE({ open: false, roleUpdated: {} })
    },
    async handleUpdate() {
      const routedEntity = await this.$getItem('routedEntity')
      const entityId = routedEntity.id
      const actionsMap = this.$store.state.user.mappedActions
      const actionId = actionsMap.get('updatePrivilege').id
      const update = {
        label: this.role.label,
        actions: this.role.actions,
      }
      try {
        this.UPDATE_LOADING(true)
        let ret = await Management.updatePrivilege(entityId, actionId, this.role.id, update)
        if (ret.success) {
          this.$store.commit('user/UPDATE_LOADING', false)
          this.handleClose()
          this.$store.commit('user/UPDATE_ALERT', {
            status: true,
            message: 'Papel <b>modificado</b> com sucesso!',
            icon: 'mdi-check-circle',
            color: 'green',
          })
        }
      } catch (e) {
        console.log('catch role update', e)
      } finally {
        this.UPDATE_LOADING(false)
      }
      this.$parent.readRoles()
    },
  },
}
</script>

<style scoped></style>
